package boids;

/**
 * A boid is an agent (animal) moving accordingt to a simple set of rules.
 * 
 * @author Nir Atias
 *
 */
public class Boid {


	/**
	 * Construct a new boid. 
	 * 
	 * @param position The initial location of the boid in the scene.
	 * @param velocity The initial velocity of the boid.
	 * @param parameters The set of configurable parameters (color, maximum velocity, etc.).
	 * @param scene The scene in which this boid operates.
	 */
	/*
	 * @pre position != null
	 * @pre velocity != null
	 * @pre parameters != null
	 * @pre scene != null
	 */
	public Boid(Point position, Point velocity, BoidParameters parameters,
			Scene scene) {
		//TODO: Add your code here
	}

	// getters
	public Point getPosition() {
		//TODO: Add your code here
	}

	public Point getVelocity() {
		//TODO: Add your code here
	}

	public BoidParameters getParameters() {
		//TODO: Add your code here
	}

	public Flock getFlock() {
		//TODO: Add your code here
	}

	// setters
	public void setPosition(Point position) {
		//TODO: Add your code here
	}

	public void setVelocity(Point velocity) {
		//TODO: Add your code here
	}

	public void setFlock(Flock flock) {
		//TODO: Add your code here
	}

	// operations
	/**
	 * This method is called by the scene object whenever an update
	 * to the Boid's state is required.
	 * 
	 * The Boid should update its velocity based on its behavioral 
	 * rules and then update its position accordingly. 
	 * 
	 * <b>Important</b>:
	 * The last line in this function should update the position. 
	 * The position should not be changed anywhere else.
	 */
	/*
	 * @post getVelocity().norm() <= getParameters().getMaxVelocity()
	 */
	public void move() {
		stayWithFlock();
		avoidOtherBoids();
		maintainFlockVelocity();
		stayInScene();
		constrainVelocity();

		position.add(velocity);
	}

	/*
	 * @post (getFlock() == null) => $prev(getVelocity()) == getVelocity()
	 */
	private void maintainFlockVelocity() {
		//TODO: Add your code here
	}

	/*
	 * @post (getFlock() == null) => $prev(getVelocity()) == getVelocity()
	 */
	private void stayWithFlock() {
		//TODO: Add your code here
	}

	/*
	 * @post getVelocity().norm() <= getParameters().getMaxVelocity()
	 */
	private void constrainVelocity() {
		//TODO: Add your code here
	}

	private void avoidOtherBoids() {
		//TODO: Add your code here
	}

	private void stayInScene() {
		//TODO: Add your code here
	}
}
